﻿Imports System
Imports System.Collections.Generic
Imports System.Text
Imports System.Management
'must reference this as well.
Namespace IDParser_VB
    Friend Class ProcessConnection
        Public Shared Function ProcessConnectionOptions() As ConnectionOptions
            Dim options As New ConnectionOptions()
            options.Impersonation = ImpersonationLevel.Impersonate
            options.Authentication = AuthenticationLevel.[Default]
            options.EnablePrivileges = True
            Return options
        End Function

        Public Shared Function ConnectionScope(ByVal machineName As String, ByVal options As ConnectionOptions, ByVal path As String) As ManagementScope
            Dim connectScope As New ManagementScope()
            connectScope.Path = New ManagementPath("\\" + machineName + path)
            connectScope.Options = options
            connectScope.Connect()
            Return connectScope
        End Function

    End Class

    Class COMPortInfo
        Public Property Name() As String
            Get
                Return m_Name
            End Get
            Set(ByVal value As String)
                m_Name = value
            End Set
        End Property
        Private m_Name As String

        Public Property Description() As String
            Get
                Return m_Description
            End Get
            Set(ByVal value As String)
                m_Description = value
            End Set
        End Property
        Private m_Description As String

        Public Sub New()
        End Sub

        Public Shared Function GetCOMPortsInfo() As List(Of COMPortInfo)
            Dim comPortInfoList As New List(Of COMPortInfo)()
            Dim options As ConnectionOptions = ProcessConnection.ProcessConnectionOptions()
            Dim connectionScope As ManagementScope = ProcessConnection.ConnectionScope(Environment.MachineName, options, "\root\CIMV2")
            Dim objectQuery As New ObjectQuery("SELECT * FROM Win32_PnPEntity WHERE ConfigManagerErrorCode = 0")
            Dim comPortSearcher As New ManagementObjectSearcher(connectionScope, objectQuery)
            Using comPortSearcher
                Dim caption As String = Nothing
                For Each obj As ManagementObject In comPortSearcher.[Get]()
                    If Not (obj Is Nothing) Then
                        Dim captionObj As Object = obj("Caption")
                        If Not (captionObj Is Nothing) Then
                            caption = captionObj.ToString()
                            ' Look for the USB->Serial VCP cable 
                            If caption.Contains("USB Serial Port") Then
                                Dim comPortInfo As New COMPortInfo()
                                comPortInfo.Name = caption.Substring(caption.LastIndexOf("(COM")).Replace("(", String.Empty).Replace(")", String.Empty)
                                comPortInfo.Description = caption
                                'comPortInfo.Description = comPortInfo.Name
                                comPortInfoList.Add(comPortInfo)
                            End If
                        End If
                    End If
                Next
            End Using
            Return comPortInfoList
        End Function
    End Class
End Namespace

