﻿Imports System
'***************************************************************

' Tokenworks PDF417 and Magnetic Stripe Parsing Library        

' © Copyright 2009, TokenWorks Inc.                      

' All rights reserved.                                          

' Redistribution and use of this code in source and/or binary   

' forms, with or without modification, are permitted provided   

' that: (1) all copies of the source code retain the above      

' unmodified copyright notice and this entire unmodified        

' section of text, (2) You or Your organization owns a valid    

' Developer License to this product from TokenWorks Inc.       

' and, (3) when any portion of this code is bundled in any      

' form with an application, a valid notice must be provided     

' within the user documentation, start-up screen or in the      

' help-about section of the application that specifies          

' TokenWorks as the provider of the Software bundled      

' with the application.                                         

'***************************************************************

Namespace BuffMgr
    ''' <summary>
    ''' Summary description for ReaderBuffMgr.
    ''' This class manages the data coming from the reader based on a time stamp.
    ''' </summary>
    Public Class ReaderBuffMgr
        Public Shared StrBuffASCII As String = ""
        ' Hold current input data from reader in ASCII format 
        Public Shared RawBytes As Byte() = New Byte(1999) {}
        ' Holds current input data in byte array
        Public Shared count As Integer = 0
        Public Shared PrevLng As Integer = 0
        Private Shared PreviousTimeStamp As Integer = 0
        ' Holds previous reader response time stampe
        Public Shared Sub ScanBuilder(ByVal StrLatestData As String, ByVal IntTickTime As Integer)
            ' If time stamp close to previous time stamp, concatenate the latest data with the previous data
            If (IntTickTime - PreviousTimeStamp) <= 901 Then
                StrBuffASCII += StrLatestData
            Else
                ' Else, flush the data and start fresh with latest string data
                StrBuffASCII = StrLatestData
            End If
            GetTimeStamp()
            'Update Time Stamp Value
        End Sub

        Public Shared Sub DataBuilder(ByVal buffer As Byte(), ByVal IntTickTime As Integer)
            ' If time stamp close to previous time stamp, concatenate the latest data with the previous data
            If (IntTickTime - PreviousTimeStamp) <= 901 Then
                If count = 0 Then
                    Array.Copy(buffer, 0, RawBytes, 0, buffer.Length)
                    'PrevLng s/b 0
                    PrevLng += buffer.Length
                End If
                If count > 0 Then
                    Array.Copy(buffer, 0, RawBytes, PrevLng, buffer.Length)
                    PrevLng += buffer.Length
                End If
                System.Math.Max(System.Threading.Interlocked.Increment(count), count - 1)
            Else
                ' Else, flush the data and start fresh with latest string data
                Array.Copy(buffer, 0, RawBytes, 0, buffer.Length)
                PrevLng = buffer.Length
                'PrevLng s/b 0
                System.Math.Max(System.Threading.Interlocked.Increment(count), count - 1)
            End If
            GetTimeStamp()
            'Update Time Stamp Value
        End Sub

        Public Shared Sub GetTimeStamp()
            PreviousTimeStamp = Environment.TickCount
        End Sub
    End Class
End Namespace
